import requests
import time
import pickle


base_url = "https://api.crowdtangle.com/"
token = "redacted_for_privacy"
# need to use offset with count e.g. (offset=0&count=100, offset=100&count=200)
antivax = "https://api.crowdtangle.com/posts?count=100&sortBy=date&token="+token+"&listIds=1741010&endDate=2023-06-02&startDate=2023-02-24"


def get_all_posts():
    offset = 0
    posts = []
    num = 0
    while len(posts) < 10000 or num < 100:
        try:
            result = requests.get(antivax+"&offset="+str(offset))
            if result is None:
                break
            num += 1
        except requests.exceptions.RequestException as e:
            print("error",e)
            continue
        if result is None or result == '' or result.status_code == 504:
            continue
        print("status", result.status_code)
        posts += result.json()["result"]["posts"]
        if len(result.json()["result"]["posts"]) <100:
            print(len(result.json()["result"]["posts"]))
            break
        print(len(posts))
        offset += 100
        time.sleep(20)
    with open('all_posts_antivax'+str(len(posts)), 'wb') as f:
        pickle.dump(posts, f)
    print("there are {} posts".format(len(posts)))


get_all_posts()
